# **Common Functionalities**

This project has a common functionalities for Kinara Engineering Applications. It has the functionalities of DataModels and the Common Utilities that are Database Connectivity, Check Auth using JWT Token, Logging the Request and Response, and a Common Response for the API's.

[GitLab Repository Link](git@gitlab.com:kinaraengineering/common.git "GitLab Repository")

## **Get the Code**

$ git clone https://gitlab.com/kinaraengineering/common.git

$ npm install

## **Build the application**

Build command is used to compile the typescript files to javascript files so the end user access the functionalities.

$ npm run build

## **Publish NPM package**

Before publishing the package compile the \*.ts files using the build command and check the publish version number (increment it by one to that of previous published version). And run below command to publish the package on NPM:

$ npm publish

## **Installation**

This is a Node.js module available through the npm registry.

Installation is done using the npm install command:

$ npm install engrcommonmodule

## **Features**

- Data Models - These are ORM based data models using Sequelizer, they have a structure of the database tables.
- Utilities - These are the basic common functionalities that are required for any packages. And each functionalities are as follows:
  - dbConfig - This file is used to establish a connection to a database. The values are being fetched from the enviroment file. SERVER_TYPE field can be True or False. If the value is False, it will allow to connection to external database like RDS.
  - check-auth - This file is used to authenticate the incoming requestes based using JWT Token.
  - addAPIHist - This file logs the APIs Reqeust and Response to the database table.
  - loggers - This file is used to console the logs.
  - response - This file is a success or failure response for API Requests.
